#include "uart.h"
//----------------------------Variables-----------------------------------
unsigned char ByteReceived = 0;
unsigned char status_uart = 0;
//--------------------------Function Interfaces---------------------------
void USART0_Init(unsigned char spcon);
void USART1_Init(unsigned char spcon);
void IRQ_uart_rx_tx();

#pragma interrupt 8 IRQ_uart_rx_tx

void USART0_Init(unsigned char spcon) {

  unsigned char tmp;

  tmp = WSR;                 //store WSR
  WSR = (tmp & 0x80) | 0xF;  //swap to HWindow15
  INT_MASK1 |= TI_RI_MASK;   //allow transmit interrupt
  WSR = (tmp & 0x80);        //swap to HWindow0
  IOC1 |= 0x20;             //Enable TX0 in P2.0
  __NOP();
  __NOP();
  SP_CON0 = spcon;           //Clear SP_CON
  BAUD_RATE0 = BAUD_LO_VAL;  //write Baud rate value
  BAUD_RATE0 = BAUD_HI_VAL;
  __NOP();
  __NOP();
  WSR = tmp;                 //Restore HWindow
}

void USART1_Init(unsigned char spcon) {
  unsigned char tmp;
  tmp = WSR;                 //store WSR
  WSR = (tmp & 0x80) | 0xF;  //swap to HWindow15
  INT_MASK1 |= TI_RI_MASK;   //allow transmit interrupt
  WSR = (tmp & 0x80);        //swap to HWindow0
  IOC1 |= 0x20;
  __NOP();
  __NOP();
  SP_CON1 = spcon;           //Clear SP_CON
  BAUD_RATE1 = BAUD_LO_VAL;  //write Baud rate value
  BAUD_RATE1 = BAUD_HI_VAL;
  __NOP();
  __NOP();
  WSR = tmp;                 //Restore HWindow
}

void IRQ_uart_rx_tx()
{
  _di_();
  status_uart = SP_STAT0;    //  
   if (status_uart&0x40)     //   
   {
      ByteReceived = SBUF_RX0;
      IOPORT1 = ByteReceived;
      SBUF_TX0 = ByteReceived;
   }
   else                      //   
   {

   }
  _ei_();
}


